# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/audio.utils.ipynb.

# %% auto 0
__all__ = ['plot_waveform']

# %% ../../nbs/audio.utils.ipynb 3
import torch
from matplotlib import pyplot as plt
import torchaudio

# %% ../../nbs/audio.utils.ipynb 4
def plot_waveform(waveform, sample_rate, title="Waveform", xlim=None, ylim=None):
   waveform = waveform.numpy()
   num_channels, num_frames = waveform.shape
   time_axis = torch.arange(0, num_frames) / sample_rate

   figure, axes = plt.subplots(num_channels, 1)
   if num_channels == 1:
       axes = [axes]
   for c in range(num_channels):
       axes[c].plot(time_axis, waveform[c], linewidth=1)
       axes[c].grid(True)
       if num_channels > 1:
           axes[c].set_ylabel(f"Channel {c+1}")
       if xlim:
           axes[c].set_xlim(xlim)
       if ylim:
           axes[c].set_ylim(ylim)
   figure.suptitle(title)
   plt.show(block=False)

